<template>
  <div id="editorMode">
    <a
      :class="{
        aFunction: true,
      }"
      v-on:click="switchCodemirrorOrBlockly()"
    >
      <i class="iconClass">
        <font-awesome-icon :icon="iconForSelectMode" size="1x" />
      </i>
    </a>
    <!-- SWITCH SINGLE OR MULTIPLE BUFFERS -->
    <a class="aFunction" v-on:click="switchMultipleOrSingleBuffer()">
      <i><font-awesome-icon :icon="iconForSwitchMode" size="1x" /></i>
    </a>
    <!-- LABEL BLOCLY OR CODEMIRROR -->
    <a
      :class="{
        aLabel: true,
        aBlocklySelected: switchLabel == TypeEditor.Blockly,
        aCodemirrorSelected: switchLabel == TypeEditor.Codemirror,
      }"
      >{{ labelEditor }}</a
    >
    <a class="aLabel">:</a>
    <!-- 10 BUFFERS -->
    <a
      :class="{
        aFunction: true,
        aBlocklySelected: labelSelectedEditor.Blockly == 0,
        aCodemirrorSelected: labelSelectedEditor.Codemirror == 0,
      }"
      v-on:click="loadThisBuffer(0)"
      >1</a
    >
    <a
      v-show="multipleBufferEnable == 1"
      v-on:click="loadThisBuffer(1)"
      :class="{
        aFunction: true,
        aBlocklySelected: labelSelectedEditor.Blockly == 1,
        aCodemirrorSelected: labelSelectedEditor.Codemirror == 1,
      }"
      >2</a
    >
    <a
      v-show="multipleBufferEnable == 1"
      v-on:click="loadThisBuffer(2)"
      :class="{
        aFunction: true,
        aBlocklySelected: labelSelectedEditor.Blockly == 2,
        aCodemirrorSelected: labelSelectedEditor.Codemirror == 2,
      }"
      >3</a
    >
    <a
      v-show="multipleBufferEnable == 1"
      v-on:click="loadThisBuffer(3)"
      :class="{
        aFunction: true,
        aBlocklySelected: labelSelectedEditor.Blockly == 3,
        aCodemirrorSelected: labelSelectedEditor.Codemirror == 3,
      }"
      >4</a
    >
    <a
      v-show="multipleBufferEnable == 1"
      v-on:click="loadThisBuffer(4)"
      :class="{
        aFunction: true,
        aBlocklySelected: labelSelectedEditor.Blockly == 4,
        aCodemirrorSelected: labelSelectedEditor.Codemirror == 4,
      }"
      >5</a
    >
    <a
      v-show="multipleBufferEnable == 1"
      v-on:click="loadThisBuffer(5)"
      :class="{
        aFunction: true,
        aBlocklySelected: labelSelectedEditor.Blockly == 5,
        aCodemirrorSelected: labelSelectedEditor.Codemirror == 5,
      }"
      >6</a
    >
    <a
      v-show="multipleBufferEnable == 1"
      v-on:click="loadThisBuffer(6)"
      :class="{
        aFunction: true,
        aBlocklySelected: labelSelectedEditor.Blockly == 6,
        aCodemirrorSelected: labelSelectedEditor.Codemirror == 6,
      }"
      >7</a
    >
    <a
      v-show="multipleBufferEnable == 1"
      v-on:click="loadThisBuffer(7)"
      :class="{
        aFunction: true,
        aBlocklySelected: labelSelectedEditor.Blockly == 7,
        aCodemirrorSelected: labelSelectedEditor.Codemirror == 7,
      }"
      >8</a
    >
    <a
      v-show="multipleBufferEnable == 1"
      v-on:click="loadThisBuffer(8)"
      :class="{
        aFunction: true,
        aBlocklySelected: labelSelectedEditor.Blockly == 8,
        aCodemirrorSelected: labelSelectedEditor.Codemirror == 8,
      }"
      >9</a
    >
    <a
      v-show="multipleBufferEnable == 1"
      v-on:click="loadThisBuffer(9)"
      :class="{
        aFunction: true,
        aBlocklySelected: labelSelectedEditor.Blockly == 9,
        aCodemirrorSelected: labelSelectedEditor.Codemirror == 9,
      }"
      >10</a
    >
    <!-- TODO: crear los 10 buffers en total -->
  </div>
</template>

<script lang="ts">
import { defineComponent, ref, onMounted, watch } from "vue";

import { FontAwesomeIcon } from "@fortawesome/vue-fontawesome";
import { library } from "@fortawesome/fontawesome-svg-core";
import {
  faCode,
  faPuzzlePiece,
  faToggleOff,
  faToggleOn,
} from "@fortawesome/free-solid-svg-icons";
library.add(faCode, faPuzzlePiece, faToggleOff, faToggleOn);

import {
  LabelEditor,
  TypeEditor,
  selectActiveLabelOfBuffer,
} from "../../host/index";

export default defineComponent({
  components: {
    "font-awesome-icon": FontAwesomeIcon,
  },
  emits: ["requestToToggleCodemirrorOrBlocklyToShow", "requesLoadThisBuffer"],
  props: ["codemirrorOrBlocklySelected"],
  setup(props, context) {
    const iconForSelectMode = ref();
    const iconForSwitchMode = ref();
    const multipleBufferEnable = ref();
    const blocklyBufferPos = ref();
    const codemirrorBufferPos = ref();
    const labelEditor = ref(LabelEditor[0]);
    const switchLabel = ref();
    const labelSelectedEditor = ref();
    const IconSwitchMultipleOrSingleBugger: Array<Array<string>> = [
      ["fas", "toggle-off"],
      ["fas", "toggle-on"],
    ];
    const IconSelectBlocklyOrCodemirror: Array<Array<string>> = [
      ["fas", "code"], // cuando está en blockly mostrará el ícono de codemirror
      ["fas", "puzzle-piece"], // cuando esté en codemirror mostrará el icono de blockly
    ];

    onMounted(() => {
      switchLabel.value = props.codemirrorOrBlocklySelected;
    });

    iconForSelectMode.value = IconSelectBlocklyOrCodemirror[0];
    const switchCodemirrorOrBlockly = (): void => {
      if (props.codemirrorOrBlocklySelected == TypeEditor.Blockly) {
        context.emit(
          "requestToToggleCodemirrorOrBlocklyToShow",
          blocklyBufferPos
        );
      } else if (props.codemirrorOrBlocklySelected == TypeEditor.Codemirror) {
        context.emit(
          "requestToToggleCodemirrorOrBlocklyToShow",
          codemirrorBufferPos
        );
      }
    };
    watch(
      () => props.codemirrorOrBlocklySelected, // optionSelected
      (optionSelected) => {
        iconForSelectMode.value = IconSelectBlocklyOrCodemirror[optionSelected];
        labelEditor.value = LabelEditor[optionSelected];
        switchLabel.value = optionSelected;
        labelSelectedEditor.value = selectActiveLabelOfBuffer(
          optionSelected,
          blocklyBufferPos.value,
          codemirrorBufferPos.value
        );
      }
    );

    multipleBufferEnable.value = 0;
    iconForSwitchMode.value =
      IconSwitchMultipleOrSingleBugger[multipleBufferEnable.value];
    const switchMultipleOrSingleBuffer = (): void => {
      if (multipleBufferEnable.value == 1) {
        console.debug("simple");
        loadThisBuffer(0);
        multipleBufferEnable.value = 0; // pasar a simple
        iconForSwitchMode.value =
          IconSwitchMultipleOrSingleBugger[multipleBufferEnable.value];
      } else {
        multipleBufferEnable.value = 1; // pasar a múltiple
        console.debug("multiple");
        iconForSwitchMode.value =
          IconSwitchMultipleOrSingleBugger[multipleBufferEnable.value];
      }
    };

    blocklyBufferPos.value = 0;
    codemirrorBufferPos.value = 0;
    labelSelectedEditor.value = selectActiveLabelOfBuffer(0, 0, 0);
    const loadThisBuffer = (buffer: number) => {
      if (props.codemirrorOrBlocklySelected == TypeEditor.Blockly) {
        if (blocklyBufferPos.value != buffer) {
          context.emit("requesLoadThisBuffer", blocklyBufferPos.value, buffer);
          blocklyBufferPos.value = buffer;
        }
      } else if (props.codemirrorOrBlocklySelected == TypeEditor.Codemirror) {
        if (codemirrorBufferPos.value != buffer) {
          context.emit(
            "requesLoadThisBuffer",
            codemirrorBufferPos.value,
            buffer
          );
          codemirrorBufferPos.value = buffer;
        }
      }
      labelSelectedEditor.value = selectActiveLabelOfBuffer(
        props.codemirrorOrBlocklySelected,
        blocklyBufferPos.value,
        codemirrorBufferPos.value
      );
    };
    return {
      // -- IMPORT --
      TypeEditor,
      // -- VARS --
      iconForSelectMode,
      blocklyBufferPos,
      codemirrorBufferPos,
      labelEditor,
      switchLabel,
      // -- METHODS --
      switchCodemirrorOrBlockly,
      switchMultipleOrSingleBuffer,
      iconForSwitchMode,
      multipleBufferEnable,
      loadThisBuffer,
      labelSelectedEditor,
    };
  },
});
</script>
<style type="text/css" media="all">
#editorMode {
  padding: 5px;
  background-color: #131516;
}

.iconClass {
  color: white;
}

.aLabel {
  padding-left: 5px;
  padding-right: 5px;
  color: white;
}

.aFunction {
  padding-left: 5px;
  padding-right: 5px;
  color: white;
}
.aFunction:hover {
  background-color: orange;
  cursor: pointer;
}
.aCodemirrorSelected {
  background-color: yellow;
  color: black;
}
.aBlocklySelected {
  background-color: blue;
  color: white;
}
</style>
